<template>
  <div>
    <el-card :body-style="cardBodyStyle">
      <el-form :inline="true">
        <el-row>

          <el-col :span="5">
            <el-form-item label="物料编码" style=" width:250px " prop="itemCd">
              <el-input v-model="query.itemCd" placeholder="请输入物料编码" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="5">
            <el-form-item label="物料名称" style="width:250px" prop="itemNm">
              <el-input v-model="query.itemNm" placeholder="请输入物料名称" clearable></el-input>
            </el-form-item>
          </el-col>

          <el-col :span="5">
            <el-form-item label="可否采购" style="width: 250px;" prop="itemCd">
              <el-select v-model="query.purchaseFlag" clearable>
                <el-option label="可采购" value="Y"></el-option>
                <el-option label="不可采购" value="N"></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="5">
            <el-form-item label="可否销售" style="width: 250px;" prop="itemCd">
              <el-select v-model="query.salesFlag" clearable>
                <el-option label="可销售" value="Y"></el-option>
                <el-option label="不可销售" value="N"></el-option>
              </el-select>
            </el-form-item>
          </el-col>

        </el-row>
      </el-form>
    </el-card>
    <ButtonBar area="top" @search="handleSearch" @add="handleAdd" @remove="handleRemoveBatch"></ButtonBar>
    <el-card :body-style="cardBodyStyle">
      <el-table :data="tableData" border highlight-current-row @selection-change="handleSelectionChange"
      >
        <el-table-column type="selection" fixed></el-table-column>
        <el-table-column v-if="true" prop="itemCd" label="物料编码" width="0" header-align="center" align="center"
                         show-overflow-tooltip>
        </el-table-column>
        <el-table-column v-if="true" prop="itemNm" label="物料名称" width="0" header-align="center" align="center"
                         show-overflow-tooltip>
        </el-table-column>
        <el-table-column v-if="true" prop="orgName" label="归属公司" width="0" header-align="center" align="center"
                         show-overflow-tooltip>
        </el-table-column>
        <el-table-column v-if="true" prop="description" label="物料说明" width="0" header-align="center" align="center"
                         show-overflow-tooltip>
        </el-table-column>
        <el-table-column v-if="true" prop="purchaseFlag" label="可否采购" width="0" header-align="center" align="center"
                         show-overflow-tooltip>
          <template #default={row}>
            <el-tag v-if="row.purchaseFlag === 'Y'" type="success"><span style="font-size: 13px">可采购</span></el-tag>
            <el-tag v-if="row.purchaseFlag === 'N'" type="danger"><span style="font-size: 13px">不可采购</span></el-tag>
          </template>
        </el-table-column>
        <el-table-column v-if="true" prop="salesFlag" label="可否销售" width="0" header-align="center" align="center"
                         show-overflow-tooltip>
          <template #default={row}>
            <el-tag v-if="row.salesFlag === 'Y'" type="success"><span style="font-size: 13px">可销售</span></el-tag>
            <el-tag v-if="row.salesFlag === 'N'" type="danger"><span style="font-size: 13px">不可销售</span></el-tag>
          </template>
        </el-table-column>
        <el-table-column v-if="true" prop="itemType" label="类别" width="0" header-align="center" align="center"
                         show-overflow-tooltip>
        </el-table-column>
        <el-table-column v-if="true" prop="unit" label="计量单位" width="0" header-align="center" align="center"
                         show-overflow-tooltip>
        </el-table-column>

      </el-table>
    </el-card>
    <el-card :body-style="cardBodyStyle">
      <el-pagination :current-page="currentPage" :page-size="pageSize" :page-sizes="pageSizes" :total="totalRows"
                     background="background" layout="total, sizes, prev, pager, next, jumper"
                     @size-change="handleSizeChange"
                     @current-change="handleCurrentChange">
      </el-pagination>
    </el-card>

    <el-dialog :close-on-click-modal="false" draggable :title="title_dialog" v-model="dialogVisible" width="1200px"
               top="5vh" @open="openDialog">
      <el-form :model="form" label-width="80px" label-position="right" inline ref="ruleFormRef" :rules="rules">
        <el-form-item label="物料名称" prop="name">
          <el-input v-model="form.name" clearable style="width: 200px"></el-input>
        </el-form-item>
        <el-form-item label="数据类型" prop="remark">
          <el-select v-model="form.remark" placeholder="请选择产品类别" clearable style="width: 200px">
            <el-option label="具体产品" value="具体产品"/>
            <el-option label="产品类别" value="产品类别"/>
          </el-select>
        </el-form-item>
        <el-form-item label="排序" prop="sortindex">
          <el-input-number min="0" v-model="form.sortindex" clearable style="width: 200px"></el-input-number>
        </el-form-item>
        <el-form-item label="上级菜单" prop="parentid">
          <el-tree-select v-model="form.parentid" :data="treeData" check-strictly :render-after-expand="false"
                          style="width: 200px" clearable/>
        </el-form-item>

      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="success" @click="handleSave(ruleFormRef)">保存</el-button>
          <el-button type="danger" @click="handleCancelSave">取消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup>
import ButtonBar from '@/components/ButtonBar.vue'

import {
  ref,
  reactive,
  onMounted,
  getCurrentInstance
} from 'vue'

const {
  proxy
} = getCurrentInstance()

import tools from '@/tools'
import {ElMessage, ElMessageBox} from 'element-plus';

const cardBodyStyle = ref(tools.style.card)
const inputStyle = ref(tools.style.input)

onMounted(() => {
  handleSearch()
  // queryNBHyjg()
})


/**
 *   查询
 */


const isUse = ref(false)
const treeData = ref([])
const query = ref({
  itemNm: '',
  itemCd: '',
  purchaseFlag: '',
  salesFlag: '',
})


const tableData = ref([])
const handleSearch = () => {
  currentPage.value = 1
  getTableData()
}

const getTableData = () => {
  var url = 'syi/wuliao/query'
  var param = {
    page: currentPage.value,
    rows: pageSize.value,
    params: JSON.stringify(query.value)
  }
  proxy.$axios.get(url, param).then(response => {
    if (response.data.code == '0') {
      for (var item of response.data.data.records) {
        item.disabled = false
      }
      tableData.value = response.data.data.records
      // console.log(response.data.data)
      console.log(tableData.value)
      totalRows.value = response.data.data.total

      isUse.value = false
    } else {
      ElMessage.error('操作失败！' + response.data.msg)
    }
  })
}
/**
 * 添加时获取树形选择器数据
 *
 */
const getTreeData = () => {
  treeData.value = []
  var url = 'syi/Leibie/getTree'
  var param = {}
  proxy.$axios.get(url, param).then(response => {
    if (response.data.code == '0') {

      response.data.data.forEach(x => {
        const treeDataNode = processNode(x)
        treeData.value.push(treeDataNode.value)
        console.log(treeData.value)
      })
    } else {
      ElMessage.error('操作失败！' + response.data.msg)
    }
  })
}

const processNode = (node) => {
  const data = ref({
    label: '',
    value: '',
    children: []
  })
  data.value.label = node.name
  data.value.value = node.id

  if (node.children && node.children.length > 0) {
    node.children.forEach(childNode => {
      // 递归处理子节点
      const childData = processNode(childNode)
      data.value.children.push(childData.value)
    })
  }
  return data
}


/**
 *   查询
 */

/**
 * 分页
 */
const currentPage = ref(1)
const totalRows = ref(0)
const pageSizes = ref([5, 10, 20, 30, 40])
const pageSize = ref(5)
const handleSizeChange = (val) => {
  pageSize.value = val
  getTableData()
}
const handleCurrentChange = (val) => {
  currentPage.value = val
  getTableData()
}
/**
 * 分页
 */
// var zph = 'ZP202412260004'
// const queryNBHyjg = ()=>{
//   var url = 'sci/JkJlxx/queryHyjg'
//   var param = {
//     zph:zph
//   }
//   proxy.$axios.get(url, param).then(response => {
//     if (response.data.code == '0') {
//       console.log(response.data.data,"测试")
//     } else {
//       ElMessage.error('操作失败！' + response.data.msg)
//     }
//   })
// }

/**
 * 新增
 */
const dialogVisible = ref(false)
const form = ref({
  name: '',
  remark: '',
  erpbm: '',
  sortindex: '',
  enabled: '1',
  parentid: '',
  laiyuan: '录入',
})
const ruleFormRef = ref()
const rules = reactive({
  name: [{
    required: true,
    message: '请输入物料名称',
    trigger: 'change' | 'blur'
  }],
  remark: [{
    required: true,
    message: '请输入',
    trigger: 'change' | 'blur'
  }],
  sortindex: [{
    required: true,
    message: '请输入',
    trigger: 'change' | 'blur'
  }],
  enabled: [{
    required: true,
    message: '请输入',
    trigger: 'change' | 'blur'
  }]
})

const title_dialog = ref('')
const handleAdd = () => {
  title_dialog.value = '新增'
  form.value = {
    name: '',
    remark: '',
    erpbm: '',
    sortindex: '',
    enabled: '',
    laiyuan: '录入',
  }
  getTreeData()
  dialogVisible.value = true
}
/**
 * 新增
 */


/**
 * 保存、修改、删除
 */

const openDialog = () => {
}

const handleSave = (ruleFormRef) => {
  if (form.value.parentid === editRow.value.id) {
    ElMessage.error('操作失败')
    return
  }
  ruleFormRef.validate((valid, fields) => {
    if (valid) {
      var url = 'syi/Leibie/save'
      var param = {
        json: JSON.stringify(form.value),
      }
      proxy.$axios.post(url, param).then(response => {
        if (response.data.code == 0) {
          form.value = response.data.data
          ElMessage({
            message: '保存成功',
            type: 'success',
          })
          getTableData()
          dialogVisible.value = false
        } else {
          // ElMessage.error('操作失败！' + response.data.msg)
          ElMessage({
            message: '操作失败' + response.data.msg,
            type: 'error'
          })
        }
      })

    } else {
      console.log('error submit!', fields)
    }
  })
}
const handleCancelSave = () => {
  dialogVisible.value = false
}

const editRow = ref({})
const handleEdit = (row) => {
  title_dialog.value = '编辑'
  getTreeData()
  editRow.value = row
  dialogVisible.value = true
  form.value = JSON.parse(JSON.stringify(row))
}
const handleDelete = (row) => {
  console.log(row.children.length)
  if (row.remark === '产品类别' && row.children.length != 0) {
    ElMessage.warning('请先删除该产品类别下的具体产品')
    return
  }
  ElMessageBox.confirm(
      '确定删除本条记录?',
      '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
        draggable: true,
      }
  )
      .then(() => {
        var url = 'syi/Leibie/remove'
        var param = {
          id: row.id
        }
        proxy.$axios.post(url, param).then(response => {
          if (response.data.code == 0) {
            ElMessage({
              type: 'success',
              message: '删除成功',
            })
            getTableData()
          } else {
            ElMessage({
              type: 'error',
              message: '删除失败' + response.data.msg
            });
          }
        });
      })
      .catch(() => {
        ElMessage({
          type: 'info',
          message: '已取消',
        })
      })
}

/**
 * 保存、修改、删除
 */

const multipleSelection = ref([])
const handleSelectionChange = (val) => {
  multipleSelection.value = val
}

const handleRemoveBatch = () => {
  console.log('handleRemoveBatch')

  if (multipleSelection.value.length < 1) {
    ElMessage({
      type: 'warning',
      message: '请选择要删除的数据!'
    })
    return
  }

  ElMessageBox.confirm('此操作将删除该数据, 是否继续?', '提示', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning'
  }).then(() => {
    var ids = []
    multipleSelection.value.forEach((item, index) => {
      ids.push(item.id)
    })
    var url = 'syi/Leibie/removeBatch'
    var param = {
      ids: JSON.stringify(ids)
    }
    proxy.$axios.post(url, param).then(response => {
      if (response.data.code == '0') {
        ElMessage({
          type: 'success',
          message: '操作成功!',
        });
        getTableData()
        dialogVisible.value = false
      } else {
        ElMessage({
          type: 'error',
          message: '操作失败!' + response.data.msg
        });
      }
    })
  }).catch(() => {
    ElMessage({
      type: 'info',
      message: '已取消删除'
    })
  })
}

let index_row
const handleChange = (row, index) => {
  // const status = row.enabled
  row.disabled = true
  index_row = index
  var url = 'syi/Leibie/save'
  var param = {
    json: JSON.stringify(row),
  }
  proxy.$axios.post(url, param).then(response => {
    if (response.data.code == 0) {
      ElMessage({
        message: '保存成功',
        type: 'success',
      })
      // isUse.value = true
      row.disabled = true

      setTimeout(() => {
        console.log('延迟中')
        getTableData()
      }, 500)

      dialogVisible.value = false
    } else {
      // ElMessage.error('操作失败！' + response.data.msg)
      ElMessage({
        message: '操作失败' + response.data.msg,
        type: 'error'
      })
    }
  })
}


</script>

<style></style>